package laya.webgl.utils {
	import laya.renders.Render;
	import laya.renders.Render;
	import laya.webgl.WebGL;
	import laya.webgl.WebGLContext;
	
	public class VertexBuffer2D extends Buffer2D {
		public static var create:Function = function(vertexStride:int, bufferUsage:int = WebGLContext.DYNAMIC_DRAW):VertexBuffer2D {
			return new VertexBuffer2D(vertexStride, bufferUsage);
		}
		
		protected var _floatArray32:Float32Array;
		
		private var _vertexStride:int;
		
		public function get vertexStride():int {
			return _vertexStride;
		}
		
		public function VertexBuffer2D(vertexStride:int, bufferUsage:int) {
			super();
			_vertexStride = vertexStride;
			_bufferUsage = bufferUsage;
			_bufferType = WebGLContext.ARRAY_BUFFER;
			Render.isFlash || (_buffer = new ArrayBuffer(8));
			getFloat32Array();
		}
		
		public function getFloat32Array():* {
			return _floatArray32 || (_floatArray32 = new Float32Array(_buffer));
		}
		
		public function bind(ibBuffer:IndexBuffer2D):void {
			(ibBuffer) && (ibBuffer._bind());
			_bind();
		}
		
		public function insertData(data:Array, pos:int):void {
			var vbdata:* = getFloat32Array();
			vbdata.set(data, pos);
			_upload = true;
		}
		
		public function bind_upload(ibBuffer:IndexBuffer2D):void {
			(ibBuffer._bind_upload()) || (ibBuffer._bind());
			(_bind_upload()) || (_bind());
		}
		
		override protected function _checkArrayUse():void {
			_floatArray32 && (_floatArray32 = new Float32Array(_buffer));
		}
		
		override protected function disposeResource():void {
			super.disposeResource();
			return;	//下面的处理可能会导致一些闪屏（黑一下）所以先去掉了。如果某个项目因为这个又闪屏了（通常是使用了粒子，导致多开了attribute），就要好好考虑怎么处理了
			//if (_glBuffer) {
			var enableAtributes:Array = Buffer._enableAtributes;
			if (!Render.isConchWebGL)
			{
				for (var i:int = 0; i < 10; i++) {
					WebGL.mainContext.disableVertexAttribArray(i);//临时修复警告和闪屏
					enableAtributes[i] = null;
				}
			}
		
			//}
		}
		
		public function destory():void {
			_byteLength = 0;
			_upload = true;
			_buffer = null;
			_floatArray32 = null;
		}
	
	}

}